checkRequire("Lua_RankBasePanel")
Lua_ChaosForestRankPanel = class("Lua_ChaosForestRankPanel", Lua_RankBasePanel)
function Lua_ChaosForestRankPanel:ctor(p)
	self:superCall("ctor", p, "ChaosForestRankPanel_skin")
end

function Lua_ChaosForestRankPanel:buildShowItem()
	self:superCall("buildShowItem")

	local item
	for i = 1, 3 do
		item = Lua_ChaosForestRankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		item:setRank(i)
		self.topArr:add(item)
	end

	self.itemList:setListCell(Lua_ChaosForestRankItem, 688, 125, 1)
	self.myCheckHurt:addClickFuntion(self, self.onCheckSelfHurt)
end

function Lua_ChaosForestRankPanel:dispose()
	self:superCall("dispose")
end

function Lua_ChaosForestRankPanel:updateRankInfo(msg)
	if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list
		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	else
		for i = 1, #msg.rank_list do
			self.rankArr:add(msg.rank_list[i])
		end
	end
	self.itemList.isPageEnd = (msg.is_end == 1)
	self:updateRankList()

	local info = msg.self_rank
	if info == nil then
		self.myNoneRankSp:setEnable(true)
		self.myNameTxt:setEnable(false)
		self.myValueTxt:setEnable(false)
		self.myCheckHurt:setEnable(false)
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end
		self.myNameTxt:setEnable(true)
		self.myValueTxt:setEnable(true)
		self.myCheckHurt:setEnable(true)

		self.myNameTxt.text = info.player_show.name
		self.myAvatarItem:setRoleId(info.player_show.id)
		self.myAvatarItem:setRoleDressUp(info.player_show.dress_info, true)
		self.myAvatarItem:setRoleLevel2(info.player_show.level)

		self.myValueTxt.text = info.value
	end
end

function Lua_ChaosForestRankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
	end
	self:updateTween()
end

function Lua_ChaosForestRankPanel:onCheckSelfHurt(go)
	Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sFightHurtCollect(DataCenter.roleData.roleId);
end