-- 神域试炼
checkRequire("Lua_RankBasePanel")
Lua_DivineDomainTrialRankPanel = class("Lua_DivineDomainTrialRankPanel", Lua_RankBasePanel)
function Lua_DivineDomainTrialRankPanel:ctor(p)
	self:superCall("ctor", p, "DivineDomainTrialRankPanel_skin")
end

function Lua_DivineDomainTrialRankPanel:buildShowItem()
	self:superCall("buildShowItem")

	local item
	for i = 1, 3 do
		item = Lua_DivineDomainTrialRankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		self.topArr:add(item)
	end
	
	self.itemList:setListCell(Lua_DivineDomainTrialRankItem, 688, 125, 1)
end

function Lua_DivineDomainTrialRankPanel:dispose()
	self:stopTimer();
	self:superCall("dispose")
end

function Lua_DivineDomainTrialRankPanel:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true
		self:addTimer("Lua_DivineDomainTrialRankPanel", 1, self, self.onTimer)
	end
end

function Lua_DivineDomainTrialRankPanel:stopTimer()
	if self.bTimer == true then
		self.bTimer = false
		self:removeTimer(self, self.onTimer)
	end
end

function Lua_DivineDomainTrialRankPanel:onTimer()
	local remainTime = self.clockTime - DataCenter.roleData.serverTime
	if remainTime > 0 then
		self.timeText:setEnable(true)
		self.timeText.text = LanUtil.formateStr(764000, Lua_TimeTransform.transSeconds1(remainTime))
	else
		self:stopTimer()
		self.timeText:setEnable(false)
	end
end

function Lua_DivineDomainTrialRankPanel:updateRankInfo(msg)
	self.clockTime = tonumber(msg.close_tick);
	if self.clockTime > 0 then
		self:startTimer()
		self:onTimer()
	else
		self:stopTimer()
	end

	-- if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list

		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	-- else
	-- 	for i = 1, #msg.rank_list do
	-- 		self.rankArr:add(msg.rank_list[i])
	-- 	end
	-- end
	self.itemList.isPageEnd = true;
	self:updateRankList() 

	local info = msg.self_rank
	if info == nil then
		self.playerId = nil;
		self.server_flag = nil;
		self.isMyself = nil;
		self.canAdmire = nil;

		self.myNoneRankSp:setEnable(true)
		self.myNameTxt:setEnable(false)
		self.myLeagueTxt.text = nil;
		self.mydescTxt_1.text = nil;
		self.mydescTxt_2.text = nil;
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		self.playerId = tonumber(info.show_role.id);
		self.server_flag = info.show_role.server_flag;
		self.isMyself = DataCenter.roleData:isMyself(self.playerId);
		self.canAdmire = info.like_state == 0;

		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end
		self.myNameTxt:setEnable(true)

		self.myNameTxt.text = info.show_role.name
		self.myAvatarItem:setRoleId(info.show_role.id)
		self.myAvatarItem:setRoleDressUp(info.show_role.dress_info, true)
		self.myAvatarItem:setRoleLevel2(info.show_role.level)


		if strIsNullOrEmpty(info.show_role.league_name) then
			self.myLeagueTxt:setLangValue(764002)
		else
			self.myLeagueTxt.text = LanUtil.formateStr(764003, info.show_role.league_name)
		end

		self.mydescTxt_1.text = LanUtil.formateStr(764004, info.difficulty);

		local hurtNum = tonumber(info.hurt);
		local value;
		local str;
		if hurtNum == 0 then
			value = info.floor;
			if value == 0 then
				str = LanUtil.getValue(764052);
			else
				str = LanUtil.formateStr(764005, value);
			end
		else
			value = numberTrans(hurtNum, nil, 1);
			str = LanUtil.formateStr(764006, value);
		end
		self.mydescTxt_2.text = str;
	end
end

function Lua_DivineDomainTrialRankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
		self.topArr[i]:setEnable(true);
	end
	self:updateTween()
end