checkRequire("Lua_RankBasePanel")
Lua_HeroRankPanel = class("Lua_HeroRankPanel", Lua_RankBasePanel)
function Lua_HeroRankPanel:ctor(p)
	self:superCall("ctor", p, "HeroRankPanel_skin")
end

function Lua_HeroRankPanel:buildShowItem()
	self:superCall("buildShowItem")
	self.itemList:setListCell(Lua_HeroRankItem, 688, 125, 1)
end

function Lua_HeroRankPanel:dispose()
	self:superCall("dispose")
end

function Lua_HeroRankPanel:updateRankInfo(msg)
	if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list
		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	else
		for i = 1, #msg.rank_list do
			self.rankArr:add(msg.rank_list[i])
		end
	end
	self.itemList.isPageEnd = (msg.is_end == 1)
	self:updateRankList()

	self.myAvatarItem:setAvatarBg("common_altas_3", "xui_common_widget_019")
	local info = msg.self_rank
	if info == nil then
		self.myNoneRankSp:setEnable(true)
		self.myIcon:setEnable(false)
		self.myNameTxt:setEnable(false)
		self.myValueTxt:setEnable(false)
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			self.myIcon:setEnable(false)
			self.myHeroTxt:setLangValue(202533)
			self.myHeroTxt:setLocation(-88, 186.5, 0)
			self.myNameTxt:setEnable(false)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end

		local config = Lua_HeroConfigData.getConfig(info.other_value)
		if config then
			self.myHeroTxt.text = config.name
			self.myHeroTxt:setLocation(-88, 205.5, 0)

			self.myIcon:setEnable(true)
			self.myNameTxt:setEnable(true)
			self.myNameTxt.text = info.player_show.name
		
			self.myAvatarItem:setRoleId(info.player_show.id)
			self.myAvatarItem:setHeroAvatar(info.other_value, nil, info.clothes_id)
		else
			self.myHeroTxt:setLangValue(202533)
			self.myHeroTxt:setLocation(-88, 186.5, 0)
			self.myIcon:setEnable(false)
			self.myNameTxt:setEnable(false)
			self.myAvatarItem:init()
			if self._myAvatarItem then self._myAvatarItem:setEnable(false) end
		end

		self.myValueTxt:setEnable(true)
		self.myValueTxt.text = spliceIconStr("number", "xui_zl1_number_10", 30, 32).." "..info.value
	end
end

function Lua_HeroRankPanel:updateTopRank()
	local info
	local heroStr
	local nameStr
	local valueStr
	local avatarStr
	for i = 1, 3 do
		heroStr = "heroTxt_"..i
		nameStr = "nameTxt_"..i
		valueStr = "valueTxt_"..i
		avatarStr = "avatarItem_"..i
		self[heroStr]:setLangValue(202533)
		self[nameStr]:setLangValue(202500)
		self[valueStr]:setEnable(false)
		if self["_"..avatarStr] then self["_"..avatarStr]:setEnable(false) end
		info = self.rankArr[i]
		if info then
			local config = Lua_HeroConfigData.getConfig(info.other_value)
			if config then
				self[heroStr].text = config.name
			
				self[avatarStr]:setRoleId(info.player_show.id)
				self[avatarStr]:setAvatarBg(nil, nil)
				self[avatarStr]:setHeroAvatar(info.other_value, nil, info.clothes_id)
			else
				self[heroStr].text = nil

				self[avatarStr]:init()
			end

			self[nameStr].text = info.player_show.name
			self[valueStr]:setEnable(true)
			self[valueStr].text = spliceIconStr("number", "xui_zl1_number_10", 26, 28).." "..info.value
		end
	end
	self:updateTween()
end