checkRequire("Lua_RankBasePanel")
Lua_LeagueRankPanel = class("Lua_LeagueRankPanel", Lua_RankBasePanel)
function Lua_LeagueRankPanel:ctor(p)
	self:superCall("ctor", p, "LeagueRankPanel_skin")
end

function Lua_LeagueRankPanel:buildShowItem()
	self:superCall("buildShowItem")

	local item
	for i = 1, 3 do
		item = Lua_LeagueRankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		item:setRank(i)
		self.topArr:add(item)
	end

	self.itemList:setListCell(Lua_LeagueRankItem, 688, 125, 1)
end

function Lua_LeagueRankPanel:updateRankInfo(msg)
	if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list
		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	else
		for i = 1, #msg.rank_list do
			self.rankArr:add(msg.rank_list[i])
		end
	end
	self.itemList.isPageEnd = (msg.is_end == 1)
	self:updateRankList()

	local info = msg.self_rank
	if info == nil then
		self.myNoneRankSp:setEnable(true)
		self.myServerTxt:setEnable(false)
		self.myNameTxt:setEnable(false)
		self.myValueTxt:setEnable(false)
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end
		self.myServerTxt:setEnable(true)
		self.myNameTxt:setEnable(true)
		if info.league_head > 0 then
			self.myServerTxt.text = LanUtil.formateStr(10047, info.server_prev)
			self.myNameTxt:setLocation(-88, 171, 0)
			self.myNameTxt.text = info.league_name
			self.myAvatarItem:setLeagueId(info.league_id)
			self.myAvatarItem:setLeagueAvatarId(info.league_head, 2, 0.5)
		else
			self.myServerTxt.text = nil
			self.myNameTxt:setLocation(-88, 186.5, 0)
			self.myNameTxt:setLangValue(202532)
			if self._myAvatarItem then self._myAvatarItem:setEnable(false) end
		end

		self.myValueTxt:setEnable(true)
		self.myValueTxt.text = spliceIconStr("number", "xui_zl1_number_10", 30, 32).." "..info.league_force
	end
end

function Lua_LeagueRankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
	end
	self:updateTween()
end