checkRequire("Lua_RankTopBaseItem")
Lua_RankBasePanel = class("Lua_RankBasePanel", Lua_DisplayObject)

function Lua_RankBasePanel:buildShowItem()
	self:superCall("buildShowItem")
	self.topPos = {{2, -230}, {-235, -290}, {236, -290}}
	self.topArr = Array()
	self.rankArr = Array()

	self.myAvatarItem = Lua_AvatarItem.new(self.content)
	self.myAvatarItem:setRectAnchor(7)
	self.myAvatarItem:setScale(0.7, 0.7, 1)
	self.myAvatarItem:setLocation(-147, 186, 0)

	self.itemList = Lua_DragList.new(self.content, 688, 540 + self.adaptHeight, Lua_AxisDefine.Vertical)
	self.itemList:setLocation(0, -175, 0)
	self.itemList.tweenId = 2008
	self.itemList.delayTween = true
	self.itemList:setListCell(Lua_RankItem, 688, 125, 1)
	self.itemList:setCellSpacing(0, 5)
end

function Lua_RankBasePanel:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	if self.topArr then
		self.topArr:dispose()
		self.topArr:clear()
		self.topArr = nil
	end
	if self._avatarItem_1 then
		self._avatarItem_1:dispose()
		self._avatarItem_1 = nil
	end
	if self._avatarItem_2 then
		self._avatarItem_2:dispose()
		self._avatarItem_2 = nil
	end
	if self._avatarItem_3 then
		self._avatarItem_3:dispose()
		self._avatarItem_3 = nil
	end
	if self._myRankNum then
		self._myRankNum:dispose()
		self._myRankNum = nil
	end
	if self.myAvatarItem then
		self.myAvatarItem:dispose()
		self.myAvatarItem = nil
	end
	if self.rankArr then
		self.rankArr:clear()
		self.rankArr = nil
	end
	DataCenter.winTweenManager:removeWinTween(self.tweenName)
	self.tweenName = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_RankBasePanel:onScreenResize(adaptHeight)
	if self.adaptHeight ~= adaptHeight then
		self:superCall("onScreenResize", adaptHeight)
		self.itemList:setContentRect(708, 540 + adaptHeight)
	end
end

function Lua_RankBasePanel.Get:avatarItem_1()
	if self._avatarItem_1 == nil then
		self._avatarItem_1 = Lua_AvatarItem.new(self.topRank_1)
		self._avatarItem_1:setScale(0.9, 0.9, 1)
		self._avatarItem_1:setLocation(0, 110, 0)
	end
	self._avatarItem_1:setEnable(true)
	return self._avatarItem_1
end

function Lua_RankBasePanel.Get:avatarItem_2()
	if self._avatarItem_2 == nil then
		self._avatarItem_2 = Lua_AvatarItem.new(self.topRank_2)
		self._avatarItem_2:setScale(0.8, 0.8, 1)
		self._avatarItem_2:setLocation(0, 100, 0)
	end
	self._avatarItem_2:setEnable(true)
	return self._avatarItem_2
end

function Lua_RankBasePanel.Get:avatarItem_3()
	if self._avatarItem_3 == nil then
		self._avatarItem_3 = Lua_AvatarItem.new(self.topRank_3)
		self._avatarItem_3:setScale(0.8, 0.8, 1)
		self._avatarItem_3:setLocation(0, 100, 0)
	end
	self._avatarItem_3:setEnable(true)
	return self._avatarItem_3
end

function Lua_RankBasePanel.Get:myRankNum()
	if self._myRankNum == nil then
		self._myRankNum = Lua_NumberImage.new(self.content)
		self._myRankNum:setRectAnchor(7)
		self._myRankNum:setLocation(-270.5, 186, 0)
		self._myRankNum.numOffsetX = -4
		self._myRankNum.numAtlas = "number"
		self._myRankNum.preStr = "xui_phb_number_"
	end
	self._myRankNum:setEnable(true)
	return self._myRankNum
end

function Lua_RankBasePanel:setData(data)
	self.data = data
	self.rankValueTxt.text = data.rank_text

	self.itemList.showTween = true
	self.itemList.isPageEnd = false
	if data.type == 22 or data.type == Lua_RankData.DIVINEDOMAINTRIAL_TYPE then -- 1002神域试炼
		self.itemList.callBackOwner = nil
		self.itemList.turnPageCallBack = nil
	else
		self.itemList.callBackOwner = self
		self.itemList.turnPageCallBack = self.turePage
	end

	local item
	for i = 1, 3 do
		item = self.topArr[i]
		if item then
			item:setEnable(false)
			item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		else
			item = self["topRank_"..i]
			if item then
				item:SetActive(false)
				LuaUtil.setObjPos(item, self.topPos[i][1], self.topPos[i][2], 0);
			end
		end
	end

	self.bRefresh = true
	self:turePage(0)
end

function Lua_RankBasePanel:updateRankList()
	local len = self.rankArr:getSize() - 3
	if len > 0 then
		self.itemList:setEnable(true)
		self.itemList:setArrayData(self.rankArr, 4)
		if self.bRefresh then
			self.itemList:moveToIndex(1, true)
		end
		self:showNone(false)
	else
		self.itemList:setEnable(false)
		self:showNone(true)
	end
	self:updateTopRank()
	self.bRefresh = false
end

function Lua_RankBasePanel:turePage(page)
	page = page or 1
	if self.data.type == 4 then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerRank(3, page)
	elseif self.data.type == 5 then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerRank(2, page)
	elseif self.data.type == 6 then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerRank(1, page)
	elseif self.data.type == 7 then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerRank(4, page)
	elseif self.data.type == Lua_RankData.LIGHT_TOWER_TYPE then
		Lua_ProxyManager.getProxy("Lua_ClimbTowerProxy"):sTowerRank(9, page)
	elseif self.data.type == Lua_RankData.LEAGUE_TYPE then
		Lua_ProxyManager.getProxy("Lua_RankProxy"):sAllianceRank(page)
	elseif self.data.type == Lua_RankData.ARENA_TYPE then
		Lua_ProxyManager.getProxy("Lua_ArenaProxy"):sRankInfo(page)
	elseif self.data.type == Lua_RankData.STAR_TRIAL_TYPE then
		Lua_ProxyManager.getProxy("Lua_StarTrialProxy"):sStarTrialRankInfo(page)
	elseif self.data.type == Lua_RankData.CHAOS_FORES_TYPE then
		Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sRankInfo(page);
	elseif self.data.type == 22 then
		Lua_ProxyManager.getProxy("Lua_ChampionshipProxy"):sRankInfo();
	elseif self.data.type == Lua_RankData.DIVINEDOMAINTRIAL_TYPE then -- 神域试炼 
		Lua_ProxyManager.getProxy("Lua_DivineDomainTrialProxy"):sGetRankInfo();
	else
		Lua_ProxyManager.getProxy("Lua_RankProxy"):sGetRankInfo(self.data.type, page)
	end
end

function Lua_RankBasePanel:showNone(value)
	if value then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/championship/xui_jys_widget_18.png", 0, -170, 0, 0)

			self.noneText = UICreate.createLabel(self.content, nil, 1.5, -220, 100, 40, 36)
			self.noneText.pivotValue = 4
			self.noneText.fontName = Lua_MyUISettings.huakangFontName
			self.noneText.alignmentValue = 4
			self.noneText.horizontalOverflowValue = 1
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("7A6C74")
			self.noneText:setLangValue(202502)
		end
		self.noneIcon:setEnable(true)
		self.noneText:setEnable(true)
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false)
			self.noneText:setEnable(false)
		end
	end
end

function Lua_RankBasePanel:updateTween()
	if not self.bRefresh then
		return
	end
	
	if self.tweenName then
		DataCenter.winTweenManager:removeWinTween(self.tweenName)
	end
	self.tweenName = DataCenter.winTweenManager:createWinTween(self.content.name, self.content.transform)
end