checkRequire("Lua_RankBasePanel")
Lua_RankPanel = class("Lua_RankPanel", Lua_RankBasePanel)
function Lua_RankPanel:ctor(p)
	self:superCall("ctor", p, "RankPanel_skin")
end

function Lua_RankPanel:buildShowItem()
	self:superCall("buildShowItem")

	local item
	for i = 1, 3 do
		item = Lua_RankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		self.topArr:add(item)
	end
end

function Lua_RankPanel:updateRankInfo(msg)
	if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list
		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	else
		for i = 1, #msg.rank_list do
			self.rankArr:add(msg.rank_list[i])
		end
	end
	self.itemList.isPageEnd = (msg.is_end == 1)
	self:updateRankList()

	local info = msg.self_rank
	if info == nil then
		self.myNoneRankSp:setEnable(true)
		self.myNameTxt:setEnable(false)
		self.myValueTxt:setEnable(false)
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end
		self.myNameTxt:setEnable(true)
		self.myValueTxt:setEnable(true)
		self.myValueTxt.pivotValue = 4
		self.myValueTxt.alignmentValue = 4
		self.myValueTxt:setLocation(230, 186.5, 0)

		self.myNameTxt.text = info.player_show.name
		self.myAvatarItem:setRoleId(info.player_show.id)
		self.myAvatarItem:setRoleDressUp(info.player_show.dress_info, true)
		self.myAvatarItem:setRoleLevel2(info.player_show.level)

		if self.data.type >= 4 and self.data.type <= Lua_RankData.LIGHT_TOWER_TYPE then
			self.myValueTxt.text = LanUtil.formateStr(202531, info.value)
		elseif self.data.type == Lua_RankData.FIGHT_TYPE then
			self.myValueTxt.pivotValue = 3
			self.myValueTxt.alignmentValue = 3
			self.myValueTxt:setLocation(150, 186.5, 0)
			self.myValueTxt.text = spliceIconStr("number", "xui_zl1_number_10", 30, 32).." "..info.value
		elseif self.data.type == Lua_RankData.MAIN_LINE_TYPE then
			local config1 = Lua_MainLineCheckpointConfigData.getConfig(info.value)
			if config1 then
				local config2 = Lua_MainLineChapterConfigData.getConfig(config1.chapter_id)
				self.myValueTxt.text = config2.name..config1.name
			else
				self.myValueTxt:setEnable(false)
			end
		elseif self.data.type == Lua_RankData.KUNXUHOLYLAND_TYPE then
			self.myValueTxt.text = LanUtil.formateStr(202536, info.value, info.sub_value, spliceIconStr("common_altas_1", "xui_common_label_06", 30, 29))
		else
			self.myValueTxt.text = info.value
		end
	end
end

function Lua_RankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
	end
	self:updateTween()
end