Lua_RankRewardDetailWindow = class("Lua_RankRewardDetailWindow", Lua_Window)
function Lua_RankRewardDetailWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_RankRewardDetailWindow"
	self.skinName = "RankRewardDetailWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_RankRewardDetailWindow:buildShowItem()
	self:superCall("buildShowItem")

	self.itemList = Lua_DragList.new(self.content, 628, 615, Lua_AxisDefine.Vertical)
	self.itemList:setListCell(Lua_RankRewardDetailItem, 628, 120, 1)
	self.itemList:setLocation(0, -80, 0)
end

function Lua_RankRewardDetailWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end

function Lua_RankRewardDetailWindow:showWin(param)
	self:superCall("showWin", param)
	self.itemList:setArrayData(param)
	self.itemList.canDrag = param and #param > 5
end























Lua_RankRewardDetailItem = class("Lua_RankRewardDetailItem", Lua_ListCell)
function Lua_RankRewardDetailItem:ctor(p)
	self:superCall("ctor", p, "RankRewardDetailItem_skin")
end

function Lua_RankRewardDetailItem:buildShowItem()
	self:superCall("buildShowItem")

	self.avatarItem = Lua_AvatarItem.new(self.content)
	self.avatarItem:setScale(0.7, 0.7, 0.7)
	self.avatarItem:setLocation(-125, 0.5, 0)
end

function Lua_RankRewardDetailItem:dispose()
	if self.avatarItem then
		self.avatarItem:dispose()
		self.avatarItem = nil
	end
	self:superCall("dispose")
end

function Lua_RankRewardDetailItem:setData(data)
	self.avatarItem:setRoleId(data.player.id)
	self.avatarItem:setRoleDressUp(data.player.dress_info)
	self.avatarItem:setRoleLevel(data.player.level)
	self.nameTxt.text = data.player.name
	self.timeTxt.text = Lua_TimeTransform.transSeconds8(data.time)
end

function Lua_RankRewardDetailItem:setCellSeqIndex(idx)
	self:superCall("setCellSeqIndex", idx)
	if idx > 3 then
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_13")
		self.rankTxt:setEnable(true)
		self.rankTxt.text = idx
	else
		self.rankBg:setAltas("common_altas_4", "xui_jys_label_1"..(idx - 1))
		self.rankTxt:setEnable(false)
	end
end