Lua_RankTopBaseItem = class("Lua_RankTopBaseItem", Lua_DisplayObject)

function Lua_RankTopBaseItem:buildShowItem()
	self:superCall("buildShowItem")
	
	self.avatarItem = Lua_AvatarItem.new(self.content)
end

function Lua_RankTopBaseItem:dispose()
	if self.avatarItem then
		self.avatarItem:dispose()
		self.avatarItem = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_RankTopBaseItem:setRank(value)
	self.bg:setAltas("rank_altas", "xui_phb_bg_"..(value + 1))
	self.rankText.text = LanUtil.formateStr(202538, convert_arab_to_chinese(value))
	if value == 1 then
		self.rankText:setLocation(0, 26, 0)
		self.rankText.fontSize = 30
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FCF6AF")

		self.nameText:setLocation(0, -26, 0)
		self.nameText.fontSize = 30
		self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")

		self.valueText:setLocation(0, -68, 0)
		self.valueText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")

		self.avatarItem:setScale(0.9, 0.9, 1)
		self.avatarItem:setLocation(0, 108, 0)
	else
		self.rankText:setLocation(0, 28, 0)
		self.rankText.fontSize = 26
		self.rankText.colorStr = Lua_ColorDefine.transColorStr("FFFFFF")

		self.nameText:setLocation(0, -13, 0)
		self.nameText.fontSize = 26
		
		self.valueText:setLocation(0, -51, 0)
		self.valueText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		if value == 2 then
			self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
			self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.nameText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
			self.valueText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end

		self.avatarItem:setScale(0.8, 0.8, 1)
		self.avatarItem:setLocation(0, 96, 0)
	end
end




















Lua_RankTopItem = class("Lua_RankTopItem", Lua_RankTopBaseItem)
function Lua_RankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_RankTopItem:setData(rankType, rankNum, data)
	self:setRank(rankNum)
	if data == nil then
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:init()
	else
		self.nameText.text = data.player_show.name
		self.valueText:setEnable(true)
		if rankType >= 4 and rankType <= Lua_RankData.LIGHT_TOWER_TYPE then
			self.valueText.text = LanUtil.formateStr(202531, data.value)
		elseif rankType == Lua_RankData.FIGHT_TYPE then
			self.valueText.colorStr = Lua_ColorDefine.transColor("F7EE80")
			self.valueText.effectColorStr = Lua_ColorDefine.transColor("541814")
			self.valueText.text = spliceIconStr("number", "xui_zl1_number_10", 26, 28).." "..data.value
		elseif rankType == Lua_RankData.MAIN_LINE_TYPE then
			local config1 = Lua_MainLineCheckpointConfigData.getConfig(data.value)
			if config1 then
				local config2 = Lua_MainLineChapterConfigData.getConfig(config1.chapter_id)
				self.valueText.text = config2.name..config1.name
			else
				self.valueText:setEnable(false)
			end
		elseif rankType == Lua_RankData.KUNXUHOLYLAND_TYPE then
			self.valueText.text = LanUtil.formateStr(202536, data.value, data.sub_value, spliceIconStr("common_altas_1", "xui_common_label_06", 26, 25))
		else
			self.valueText.text = data.value
		end

		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info, true)
		self.avatarItem:setRoleLevel2(data.player_show.level)
	end
end




















Lua_ChaosForestRankTopItem = class("Lua_ChaosForestRankTopItem", Lua_RankTopBaseItem)
function Lua_ChaosForestRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_ChaosForestRankTopItem:buildShowItem()
	self:superCall("buildShowItem")
	self.checkHurt = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_yasl_button_6", 0, 0, 0, 0)
	self.checkHurt:addClickFuntion(self, self.onCheckHurt)
end

function Lua_ChaosForestRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.checkHurt:setLocation(0, -105, 0)
	else
		self.checkHurt:setLocation(0, -85, 0)
	end
end

function Lua_ChaosForestRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:init()
		self.checkHurt:setEnable(false)
	else
		self.nameText.text = data.player_show.name
		self.valueText:setEnable(true)
		self.valueText.text = data.value

		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info, true)
		self.avatarItem:setRoleLevel2(data.player_show.level)

		self.checkHurt:setEnable(true)
	end
end

function Lua_ChaosForestRankTopItem:onCheckHurt(go)
	if self.data == nil then
		return
	end
	Lua_ProxyManager.getProxy("Lua_ChaosForestProxy"):sFightHurtCollect(self.data.player_show.id);
end




















Lua_LeagueRankTopItem = class("Lua_LeagueRankTopItem", Lua_RankTopBaseItem)
function Lua_LeagueRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_LeagueRankTopItem:buildShowItem()
	self:superCall("buildShowItem")

	self.serverText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22)
	self.serverText.pivotValue = 4
	self.serverText.alignmentValue = 4
	self.serverText.horizontalOverflowValue = 1
	self.serverText.verticalOverflowValue = 1
	self.serverText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
	self.serverText:setEffectDistance(2, 2)
end

function Lua_LeagueRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.nameText:setLocation(0, -51, 0)
		self.valueText:setLocation(0, -85, 0)
		self.serverText:setLocation(0, -13, 0)
		self.serverText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
	else
		self.nameText:setLocation(0, -39, 0)
		self.valueText:setLocation(0, -66, 0)
		self.serverText:setLocation(0, -5, 0)
		self.serverText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		if value == 2 then
			self.serverText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.serverText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end
	end
end

function Lua_LeagueRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:init()
		self.serverText:setEnable(false)
	else
		self.nameText.text = data.league_name

		self.valueText:setEnable(true)
		self.valueText.text = spliceIconStr("number", "xui_zl1_number_10", 26, 28).." "..data.league_force

		self.avatarItem:setLeagueId(data.league_id)
		self.avatarItem:setLeagueAvatarId(data.league_head, 2, 0.55)

		self.serverText:setEnable(true)
		self.serverText.text = LanUtil.formateStr(10047, data.server_prev)
	end
end




















Lua_StarTrialRankTopItem = class("Lua_StarTrialRankTopItem", Lua_RankTopBaseItem)
function Lua_StarTrialRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_StarTrialRankTopItem:buildShowItem()
	self:superCall("buildShowItem")

	self.starText = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 22)
	self.starText.pivotValue = 4
	self.starText.alignmentValue = 4
	self.starText.horizontalOverflowValue = 1
	self.starText.verticalOverflowValue = 1
	self.starText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
	self.starText:setEffectDistance(2, 2)
end

function Lua_StarTrialRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.nameText:setLocation(0, -18, 0)
		self.valueText:setLocation(0, -86, 0)
		self.starText:setLocation(0, -52, 0)
		self.starText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
	else
		self.nameText:setLocation(0, -7, 0)
		self.valueText:setLocation(0, -68, 0)
		self.starText:setLocation(0, -39, 0)
		self.starText.colorStr = Lua_ColorDefine.transColor("FFFFFF")
		if value == 2 then
			self.starText.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.starText.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end
	end
end

function Lua_StarTrialRankTopItem:setData(rankType, rankNum, data)
	self.data = data
	if data == nil then
		self.nameText:setLangValue(202500)
		self.valueText:setEnable(false)
		self.avatarItem:init()
		self.starText:setEnable(false)
	else
		self.nameText.text = data.player_show.name
		self.valueText:setEnable(true)
		if data.sub_value > 0 then
			local vo = DataCenter.starTrialUitl:getStageVo(data.sub_value)
			self.valueText.text = LanUtil.formateStr(201615, vo.chapter, vo.index)
		else
			self.valueText.text = nil
		end

		self.starText:setEnable(true)
		self.starText.text = spliceIconStr("common_altas_1", "xui_common_label_06", 26, 25)..data.value

		self.avatarItem:setRoleId(data.player_show.id)
		self.avatarItem:setRoleDressUp(data.player_show.dress_info, true)
		self.avatarItem:setRoleLevel2(data.player_show.level)
	end
end











Lua_DivineDomainTrialRankTopItem = class("Lua_DivineDomainTrialRankTopItem", Lua_RankTopBaseItem)
function Lua_DivineDomainTrialRankTopItem:ctor(p)
	self:superCall("ctor", p, "RankTopItem_skin")
end

function Lua_DivineDomainTrialRankTopItem:buildShowItem()
	self:superCall("buildShowItem")

	self.hurtTxt = UICreate.createLabel(self.content, nil, 0, -100, 100, 32, 22)
	self.hurtTxt.pivotValue = 4
	self.hurtTxt.alignmentValue = 4
	self.hurtTxt.horizontalOverflowValue = 1
	self.hurtTxt.verticalOverflowValue = 1
	self.hurtTxt.colorStr = Lua_ColorDefine.transColor("FFFFFF")
	self.hurtTxt.effectStyle = 2;
	self.hurtTxt:setEffectDistance(2, 2)
end

function Lua_DivineDomainTrialRankTopItem:setRank(value)
	self:superCall("setRank", value)
	if value == 1 then
		self.hurtTxt:setLocation(0, -100, 0)
		self.hurtTxt.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
	else
		self.hurtTxt:setLocation(0, -82, 0)
		if value == 2 then
			self.hurtTxt.effectColorStr = Lua_ColorDefine.transColorStr("606A93")
		else
			self.hurtTxt.effectColorStr = Lua_ColorDefine.transColorStr("876A2A")
		end
	end
end

--Lua_RankTopBaseItem
function Lua_DivineDomainTrialRankTopItem:setData(rankType, rankNum, data)
	self:setRank(rankNum)
	self.data = data
	if data == nil then
		self.playerId = nil;
		self.server_flag = nil;
		self.isMyself = nil;
		self.canAdmire = nil;

		self.nameText:setLangValue(202500)
		self.valueText.text = nil;
		self.hurtTxt.text = nil;
		self.avatarItem:init()	else
		self.playerId = tonumber(data.show_role.id);
		self.server_flag = data.show_role.server_flag;
		self.isMyself = DataCenter.roleData:isMyself(self.playerId);
		self.canAdmire = data.like_state == 0;


		self.nameText.text = data.show_role.name
		self.valueText.text = LanUtil.formateStr(764004, data.difficulty);

		local hurtNum = tonumber(data.hurt);
		local value = hurtNum == 0 and data.floor or numberTrans(hurtNum, nil, 1);
		self.hurtTxt.text = hurtNum == 0 and LanUtil.formateStr(764005, value) or LanUtil.formateStr(764006, value);

		self.avatarItem:setRoleId(data.show_role.id)
		self.avatarItem:setRoleDressUp(data.show_role.dress_info, true)
		self.avatarItem:setRoleLevel2(data.show_role.level)
	end
end