checkRequire("Lua_RankBasePanel")
Lua_StarTrialRankPanel = class("Lua_StarTrialRankPanel", Lua_RankBasePanel)
function Lua_StarTrialRankPanel:ctor(p)
	self:superCall("ctor", p, "StarTrialRankPanel_skin")
end

function Lua_StarTrialRankPanel:buildShowItem()
	self:superCall("buildShowItem")

	local item
	for i = 1, 3 do
		item = Lua_StarTrialRankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		item:setRank(i)
		self.topArr:add(item)
	end

	self.itemList:setListCell(Lua_StarTrialRankItem, 688, 125, 1)
end

function Lua_StarTrialRankPanel:updateRankInfo(msg)
	if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list
		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	else
		for i = 1, #msg.rank_list do
			self.rankArr:add(msg.rank_list[i])
		end
	end
	self.itemList.isPageEnd = (msg.is_end == 1)
	self:updateRankList()

	local info = msg.self_rank
	if info == nil then
		self.myNoneRankSp:setEnable(true)
		self.myNameTxt:setEnable(false)
		self.myValueTxt:setEnable(false)
		if self._myRankNum then self._myRankNum:setEnable(false) end
		self.myAvatarItem:init()
	else
		if info.rank < 1 then
			self.myNoneRankSp:setEnable(true)
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			self.myNoneRankSp:setEnable(false)
			self.myRankNum.num = info.rank
		end
		self.myNameTxt:setEnable(true)
		self.myValueTxt:setEnable(true)

		self.myNameTxt.text = info.player_show.name
		self.myAvatarItem:setRoleId(info.player_show.id)
		self.myAvatarItem:setRoleDressUp(info.player_show.dress_info, true)
		self.myAvatarItem:setRoleLevel2(info.player_show.level)

		self.myStarTxt.text = spliceIconStr("common_altas_1", "xui_common_label_06", 30, 29)..info.value
		if info.sub_value <= 0 then
			self.myValueTxt.text = LanUtil.formateStr(201615, 0, 0)
		else
			local vo = DataCenter.starTrialUitl:getStageVo(info.sub_value)
			self.myValueTxt.text = LanUtil.formateStr(201615, vo.chapter, vo.index)
		end
	end
end

function Lua_StarTrialRankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
	end
	self:updateTween()
end